Subject: Re: [PATCH 09/19] usbnet: smsc95xx: Connect to phydev

From: Andrew Lunn <[email-masked]>
Date: Thu, 3 Jan 2019 14:22:50 +0100

On Thu, Jan 03, 2019 at 02:10:30AM +0100, Marek Vasut wrote:
> Add code to detect and connect to PHY. The internal PHY of the SMSC95xx
> is a regular SMSC LAN8700 and the driver only supports the internal PHY,
> so just use the SMSC PHY driver to configure the PHY. Note that the
> driver does a lot of extra configuration of the PHY, which is left in
> to avoid breakage. Some of the extra configuration is sorted out by
> later patches in this series.

Hi Marek

A MAC driver is not expected to touch the PHY at all. Please try to
remove as much of the extra configuration as possible, adding it to
the LAN8700 PHY driver as needed.

You also have to be careful of locking. phylib takes the phydev lock
when calling into the PHY driver. Anything the MAC does to the PHY is
not going to be done with this lock held. So bad things can happen.

    Andrew